'use strict';

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const _require = require('oauth'),
      OAuth = _require.OAuth;

const qs = require('querystring');

const FanfouError = require('./ff-error');

_extends(OAuth.prototype, {
  getXAuthAccessToken(username, password, callback) {
    const xauthParams = {
      'x_auth_mode': 'client_auth',
      'x_auth_password': password,
      'x_auth_username': username
    };

    this._performSecureRequest(null, null, this._clientOptions.accessTokenHttpMethod, this._accessUrl, xauthParams, null, null, function (error, data, response) {
      if (error) {
        if (response) {
          response.body = data;
          callback(new FanfouError(response));
        } else {
          callback(error);
        }
      } else {
        const results = qs.parse(data);
        const oauthAccessToken = results['oauth_token'];
        delete results['oauth_token'];
        const oauthAccessTokenSecret = results['oauth_token_secret'];
        delete results['oauth_token_secret'];
        callback(null, oauthAccessToken, oauthAccessTokenSecret, results);
      }
    });
  }

});

_extends(OAuth.prototype, {
  _getSignature(method, url, parameters, tokenSecret) {
    if (this.fakeHttps) url = url.replace('https', 'http');

    const signatureBase = this._createSignatureBase(method, url, parameters);

    return this._createSignature(signatureBase, tokenSecret);
  }

});

module.exports = OAuth;